y/***********************************************************************/
/*    ALERTTRK.C - Source to send AlertTrack Alert                     */
/*                                                                     */
/*    Copyright (c) e. g. Software Inc, 1993.  All Rights Reserved.    */
/*                                                                     */
/*                e. g. Software Inc.                                  */
/*                319 SW Washington Suite 706                          */
/*                Portland OR, 97204                                   */
/*                (503) 294-7025                                       */
/*                (503) 294-7130 FAX                                   */
/*                                                                     */
/***********************************************************************/

typedef BYTE       char;

#include "allhdrs.h"			// All Netware 'C' Headers
#include "alerttrk.h"


#define	TRUE              1
#define	FALSE            	0
#define	ACP_SIMPLE_CMD		0x4000

typedef struct
{
	WORD				wCmd;
	BYTE				Data[576-sizeof(IPX_HEADER)];

} SEND_PACKET, * LP_SEND_PACKET;


BYTE	SCP_SendPacket(BYTE *lpszServerName, BYTE *lpyPacket, WORD wPacketSize)
{
	long	dwObjectID = (long) -1L;
	BYTE	szObjectName[48];
	WORD	wFoundType;
	BYTE	byPropertiesFlag, byObjectFlag, byObjectSecurity;

	WORD	wServerSocket;			// Server socket established with OpenConnSocket(...)
	BYTE	yServerNetwork[4];	// Which network is the server located on
	BYTE	yServerNode[6];		// What node?

	BYTE	yPropertyValue[128];
	BYTE	fMoreSegs, fPropFlag;

	long	transportTime;

	IPX_ECB			SendECB;
	IPX_HEADER		SendPacketHeader;	    	// Standard IPX header
	WORD				wCmd = ACP_SIMPLE_CMD;


	dwObjectID = (long) -1L;

 	if (ScanBinderyObject(lpszServerName, OT_ALERTTRACK_SERVER, (long *) &dwObjectID,
				(char *) szObjectName, &wFoundType,
				(char *) &byPropertiesFlag, (char *) &byObjectFlag,
				(char *) &byObjectSecurity) != SUCCESSFUL )

		return(FALSE);


	memset(yPropertyValue, 0x0, sizeof(yPropertyValue));

	if (ReadPropertyValue(szObjectName, OT_ALERTTRACK_SERVER, "NET_ADDRESS", 1, yPropertyValue, &fMoreSegs, &fPropFlag) != SUCCESSFUL)
		return(FALSE);

	// Extract our Network, Node, & Socket Address
	memcpy((BYTE *) &yServerNetwork[0], (BYTE *) &yPropertyValue[0], 4);
	memcpy((BYTE *) &yServerNode[0], (BYTE *) &yPropertyValue[4], 6);
	memcpy((BYTE *) &wServerSocket, (BYTE *) &yPropertyValue[10], 2);


	// Do the Sending...

	memset(&SendPacketHeader, 0x0, sizeof(IPX_HEADER));

	// Setup IPX Addressing to return the packet
	SendPacketHeader.packetType=4;
	SendPacketHeader.destSocket=wServerSocket;

	memcpy(&SendPacketHeader.destNet, (BYTE *) &yServerNetwork[0], sizeof(SendPacketHeader.destNet));
	memcpy(SendPacketHeader.destNode, (BYTE *) &yServerNode[0], sizeof(SendPacketHeader.destNode));

	// Initialize ECB
	SendECB.socket = NULL;
	IpxGetLocalTarget((unsigned char *) &SendPacketHeader.destNet, &SendECB, &transportTime);

	SendECB.semHandle = NULL;	// NOT used on a IPXSend!
	SendECB.fragCount = 3;
	SendECB.fragList[0].fragAddress = &SendPacketHeader;
	SendECB.fragList[0].fragSize = sizeof(IPX_HEADER);

	SendECB.fragList[1].fragAddress = &wCmd;
	SendECB.fragList[1].fragSize = sizeof(WORD);

	SendECB.fragList[2].fragAddress = lpyPacket;
	SendECB.fragList[2].fragSize = wPacketSize;


	// These are ignored by a IpxSend(...) but it looks good to init them anyway.
	SendECB.next = NULL;
	SendECB.prev = NULL;
	SendECB.queueHead = NULL;

	if (IpxSend(wServerSocket, &SendECB) == ESUCCESS)
		return(TRUE);

	return(FALSE);
}



/****************************************************************************/
/* Send a message to an AlertTrack server                                   */
/*                                                                          */
/* The alert is addressed to a recipient in the system which should         */
/* be configured to receive the alert through the different devices.        */
/*                                                                          */
/* BYTE *lpszServerName  - AlertTrack server name                           */
/* BYTE *lpszRecipient   - Recipient Name                                   */
/* BYTE *lpszFromAppName - Sending application name                         */
/* BYTE *lpszMessage       - The actual message                             */
/* BYTE  yPriority       - Priority (0-highest, 5-lowest)                   */
/*                                                                          */
/****************************************************************************/
BYTE	AlertTrack_SendAlert(BYTE *lpszServerName, BYTE *lpszRecipient, BYTE *lpszFromAppName, BYTE *lpszMessage, BYTE yPriority)
{

	ALERT_DATA_PACKET	AlertTrackPacket;

	memset((BYTE *) &AlertTrackPacket, 0x0, sizeof(ALERT_DATA_PACKET));

	AlertTrackPacket.yPacketType = PACKET_TYPE_RECIPIENT;

	strcpy((BYTE *) &AlertTrackPacket.szRecipientName, lpszRecipient);
	strcpy((BYTE *) &AlertTrackPacket.szFromAppName, lpszFromAppName);
	strcpy((BYTE *) &AlertTrackPacket.szMessage, lpszMessage);

	AlertTrackPacket.yPriority = yPriority;

	return(SCP_SendPacket(lpszServerName, (BYTE *) &AlertTrackPacket, sizeof(ALERT_DATA_PACKET)));
}


