/*
    ACPGLBLS.H - Structure definitions and defines that are shared
                 between the ACP.DLL and ACP.NLM modules.

    Copyright (c) e. g. Software Inc, 1993.  All Rights Reserved.

                e. g. Software Inc. 
                319 SW Washington
                Suite 706
                Portland OR, 97201
                (503) 294-7025
                (503) 294-7130 FAX
 
*/


#define	OT_ACP_SERVER	0x07F3

#define	MAXIMUM_IPX_PACKET_SIZE	576
#define	MAXIMUM_PACKETS_IN_ACP_COMMAND	128	// This aprx 68+K, but well only use 64K

#define	MILISEC_PER_TICK	55
#define	TICKS_PER_SECOND	18
#define	ONE_SECOND			1000

#define	ACP_ACK	0x0021
#define	ACP_NAK	0x0016

#define	ACP_SUCCESS		(0)
#define	ACP_FAILURE		(-1)
#define	ACP_TIMEOUT		(-2)

#define	ACP_ERROR_BadPacket			0x8000
#define	ACP_ERROR_OutOfMemory		0x8001
#define	ACP_ERROR_OutOfThreads		0x8002
#define	ACP_ERROR_OutOfSockets		0x8003
#define	ACP_ERROR_OutOfSemaphores	0x8004
#define	ACP_ERROR_OutOfConnections	0x8005

#define	ACP_ERROR_ConnectionAlreadyOpen	0x8100

#define	ACP_ABORT_COMMAND	0x8000

#define	ACP_OPEN_CONNECT	0x0100
#define	ACP_CLOSE_CONNECT	0x0101
#define	ACP_SEND_A_BUFFER	0x0200

#define	ACP_SIMPLE_CMD		0x4000

//Ŀ
//   STRUCTURES  
//

#ifndef	_NETWARE_NLM
#ifndef RC_INVOKED
#pragma pack(1)         /* Assume byte packing throughout */
#endif  /* RC_INVOKED */
#endif


typedef struct
{
	WORD	wSCP;						// Command ID (i.e. DataBuffer(...)
#ifdef	_NETWARE_NLM	// NO far parameter
} SCP_COMMAND, * LPSCP_COMMAND;
#else
} SCP_COMMAND, far * LPSCP_COMMAND;
#endif


typedef struct
{
	WORD	wACP;						// Command ID (i.e. OpenConnectiion(...), CloseConnection(...), SendABuffer(...)
	WORD	wAckNak;					// Ack/Nak for replying/resending request
	WORD	wRetVal;					// Success/Failure for OpenConnection(...)

	WORD	wConnectionNum;		// Logical connection number w/Windows ACP.DLL

	WORD	wMaxPackets;			// How many packet in this command
	WORD	wPacketNum;				// What packet number is this?
	WORD	wLastPacketSize;		// Size of the last packet.

	WORD	wCmdSignature;			// Unique for each NEW command

#ifdef	_NETWARE_NLM	// NO far parameter
} ACP_COMMAND, * LPACP_COMMAND;
#else
} ACP_COMMAND, far * LPACP_COMMAND;
#endif

typedef union
{
	// ============================================
	// The following fields are filled in by either
	// the server or workstation upon calling.
	// ============================================

	struct
	{
		WORD	wWorkstationSocket;				// The socket that our Windows
														// client has opened.

		WORD	wNumberOfWindowsRcxBuffers;	// This helps in the flow of info
														// by telling the server how many
														// ECBS our Windows client has.

	} OpenConnection;

//	struct						// Used as a place marker
//	{								// Incase I decide to tell the server
//		WORD	wVOID;			// something upon CloseConnSocket(...)
//	} CloseConnection;


	struct
	{
		WORD	wCount;			// Number of BAD packets to resend
		WORD	wPacketList[MAXIMUM_PACKETS_IN_ACP_COMMAND];	// Packet number(s) to resend

	} ResendPackets;

#ifdef	_NETWARE_NLM	// NO far parameter
} ACP_REQ, * LPACP_REQ;
#else
} ACP_REQ, far * LPACP_REQ;
#endif

typedef union
{
	// ============================================
	// The following fields are filled in by either
	// the server or workstation upon calling.
	// ============================================

	struct
	{
		WORD	wServerSocket;			// What socket is OUR thread
											// assigned to.
		WORD	wNumberOfServerRcxBuffers;		// This helps in the flow of info
														// by telling the workstation how
														// many ECBS the server has
	} OpenConnection;

//	struct								// Used as a place marker
//	{										// In-case I decide to tell
//		WORD	wVOID;					// workstation something 
//	} CloseConnection;				// upon a CloseConnSocket

	struct
	{
		WORD	wCount;					// Number of BAD packets to resend
		WORD	wPacketList[MAXIMUM_PACKETS_IN_ACP_COMMAND];		// Packet number(s) to resend

	} ResendPackets;

#ifdef	_NETWARE_NLM	// NO far parameter
} ACP_REPLY, * LPACP_REPLY;
#else
} ACP_REPLY, far * LPACP_REPLY;
#endif


#ifndef	_NETWARE_NLM
#ifndef RC_INVOKED
#pragma pack()         /* Assume byte packing throughout */
#endif  /* RC_INVOKED */
#endif

