/*
    ALERTCOM.C - Source to build ALERTCOM.DLL

    Copyright (c) e. g. Software Inc, 1993.  All Rights Reserved.

                e. g. Software Inc.
                319 SW Washington
                Suite 706
                Portland OR, 97204
                (503) 294-7025
                (503) 294-7130 FAX
*/

//
//    DEFINES    
//

#define	ACP_SIMPLE_CMD		0x4000

#define	MAX_ECBS					16

#define	SWAPBYTE(value) ((value << 8) | (value >> 8))


//
//    INCLUDES   
//

#include <windows.h>
#include <dos.h>
#include	<memory.h>
#include	<string.h>

#ifdef	_WINDOWS
#define	WINDOWS	
#endif

#include	<nwipxspx.h>
#include	<nwcalls.h>

#include "alrtglbl.h"			// Defines & Structs used by WINdows apps
#include "alertcom.h"		// Defines & Structs used by WINdows apps


//
//   STRUCTURES  
//

#define	MAXIMUM_IPX_PACKET_SIZE	576


typedef struct
{
	WORD	wSCP;						// Command ID (i.e. DataBuffer(...)
} SCP_COMMAND, far * LPSCP_COMMAND;

typedef struct
{
	ECB			theECB;
	IPXHeader	Header;
	SCP_COMMAND	Cmd;

	BYTE			Data[MAXIMUM_IPX_PACKET_SIZE - (sizeof(IPXHeader) + sizeof(SCP_COMMAND))];

}	SCP_PACKET, far * LPSCP_PACKET;

//
// We keep a table of .DLL's registered with us so
// we know about them.
//
//
typedef	struct
{
	BOOL	fInUse;

	WORD			wSCP_Server_OT;
	SCP_PACKET	SendPacket;

}	DLL_CLIENT, far *LPDLL_CLIENT;


//
//
// DATA 
//

HINSTANCE	hGlobalInstance=NULL;
DWORD			IPXTaskID=(DWORD) (-1L);	// We use -1 to make NETWARE.DLL manage our ECB's

//
// These are a table of the Windows
// apps that are registered with 
// this .DLL

#define	MAX_SCP_CLIENTS		8

WORD				wSCP_Clients=(WORD) (-1);
DLL_CLIENT		DLL_Clients[MAX_SCP_CLIENTS];


// Author - W. Glen Boyd 3/24/93
//Ŀ
//          LibMain                                            
//                                                             
//  Performs all initialization necessary for this control dll 
//  It is called by the entry point of the library, LibEntry   
//  (in file libentry.asm).                                    
//                                                             
//  Saves the library instance handle in a global (hLibInst),  
//  registers the control's class, and                         
//  initializes the library's local heap.                      
//                                                             
//  PARAMETERS:                                                
//    HANDLE  hInstance    handle to the library's instance    
//    WORD    wDataSegment library data segment                
//    WORD    wHeapSize    library's initial local heap size   
//    LPSTR   lpszCmdLine  command line arguments              
//                                                             
//  RETURNS:                                                   
//    HANDLE  hLibInst  the library instance                   
//                  if the class has been registered and       
//                  initialization has succeeded               
//            NULL  initialization process has failed          
//                                                             
//                                                             
//

BOOL FAR PASCAL LibMain(HANDLE hInstance,
								WORD	wDataSegment,
								WORD	wHeapSize,
								LPSTR	lpszCmdLine)
{
	if(wHeapSize != 0)
		UnlockData(0);

	hGlobalInstance = hInstance;		// Needed by other functions

	return(TRUE);
}


// Author - W. Glen Boyd 3/24/93
//Ŀ
//          WEP                                                
//                                                             
//  This is the library's exit point: it is called when the    
//  library is unloaded.                                       
//                                                             
//
/*
BOOL __export FAR PASCAL _WEP (int bSystemExit)
{
	//
	// The following keeps the system running if your Windows app
	// bombs out without de-registering.  With this current
	// release of NETWARE.DLL and Windows 3.1 it expects to have
	// everybody release themselves nicely.
	//
	if (wSCP_Clients != NULL)
	{
		int	i;

		for(i=0;i<MAX_SCP_CLIENTS;i++)
			if (SCP_ConnectionTable[i].fInUse == TRUE)
				SCP_DeRegister(i);
	}
	
	return TRUE;
}
*/

// Author - W. Glen Boyd 3/24/93
// Ŀ
//                                                                         
//  SCP_Register( VOID )                                                   
//                                                                         
//  Function to register an application with this DLL.                     
//                                                                         
//  Parameters:                                                            
//                                                                         
//                                                                         
//  Returns:                                                               
//                                                                         
//       ID - Identification index for the registered application.         
//       SCP_FAILURE - Could not register with the DLL.                    
//                                                                         
// 

WORD	__export	FAR PASCAL SCP_Register(WORD wSCP_Server_OT)
{
	WORD  wID;

	int	i;

	if (wSCP_Clients == -1)
	{
		// Initialize one time .DLL stuff!

		for(i=0;i<MAX_SCP_CLIENTS;i++)
			DLL_Clients[i].fInUse = FALSE;

		wSCP_Clients = 0;
	}

	if (wSCP_Clients+1 >= MAX_SCP_CLIENTS)
		return((WORD) SCP_FAILURE);

	if (!wSCP_Clients)
	{
		// Initialize stuff for this .DLL
		int	ret;
		NWCCODE nwCCode;

		nwCCode= NWCallsInit(NULL,NULL);

		if (nwCCode)
			return((WORD) SCP_FAILURE);

		IPXTaskID=(DWORD) (-1L);

		ret=IPXInitialize( (LPDWORD) &IPXTaskID, 8, 576);
		
		if (ret)
			return((WORD) SCP_FAILURE);
	}

	++wSCP_Clients;

	for(i=0;i<MAX_SCP_CLIENTS;i++)
		if (DLL_Clients[i].fInUse == FALSE)
		{
			wID=i;
			DLL_Clients[i].fInUse = TRUE;
			DLL_Clients[i].wSCP_Server_OT = SWAPBYTE(wSCP_Server_OT);
			break;
		}

	return(wID);
}

// Author - W. Glen Boyd 3/24/93
// Ŀ
//                                                                         
//  SCP_DeRegister(WORD wDLL_ID)                                           
//                                                                         
//  Function to remove an application from registry with this NWSCP.DLL    
//                                                                         
//  Parameters:                                                            
//                                                                         
//    wDLL_ID - Handle returned from SCP_Register()                        
//                                                                         
//  Returns:                                                               
//                                                                         
//       SCP_SUCCESS - Successfully removed from list                      
//       SCP_FAILURE - Error, was removed anyway                           
//                                                                         
// 

WORD __export	FAR PASCAL SCP_DeRegister(WORD wDLL_ID)
{
	WORD  wRetCode = SCP_SUCCESS;

	if (!(--wSCP_Clients))
	{
		// DeInitialize
		wRetCode = IPXSPXDeinit(IPXTaskID);

		IPXTaskID=(DWORD) (-1L);
	}

	DLL_Clients[wDLL_ID].fInUse = FALSE;

	return(wRetCode);
}

// Author - W. Glen Boyd 3/24/93
// Ŀ
//                                                                         
//  SCP_GetServerCount(WORD wDLL_ID)                                       
//                                                                         
//  Function to return number of servers of passed type                    
//                                                                         
//  Parameters:                                                            
//                                                                         
//  Returns:                                                               
//       Number of servers                                                 
//       SCP_FAILURE - Could not access the network                        
//                                                                         
// 

WORD __export	FAR PASCAL SCP_GetServerCount(WORD wDLL_ID)
{
	WORD	wCount=0;

	NWOBJ_ID			dwObjectID = (NWOBJ_ID) -1;
	BYTE				szServerName[50];
	NWFLAGS			byPropertiesFlag, byObjectFlag, byObjectSecurity;
	NWOBJ_TYPE		wSearchObjectType=OT_FILE_SERVER;
	NWOBJ_TYPE		wFoundServerType;
	NWCONN_HANDLE	nwConnectionHandle;
	NWCCODE			nwCCode;

	if (NWGetDefaultConnectionID(&nwConnectionHandle) != SUCCESSFUL)
		return(wCount);

	wSearchObjectType=DLL_Clients[wDLL_ID].wSCP_Server_OT;

	while((nwCCode=NWScanObject(nwConnectionHandle,
				"*",
				wSearchObjectType,
				&dwObjectID,
				(LPSTR) szServerName, &wFoundServerType,
				&byPropertiesFlag, &byObjectFlag,
				&byObjectSecurity)) == SUCCESSFUL)
	{
		++wCount;
	}

	return(wCount);
}

// Author - W. Glen Boyd 3/24/93
// Ŀ
//                                                                         
//  SCP_GetServerList(WORD wDLL_ID, lpServerList, wStartNum, *lpwMaxRet)   
//                                                                         
//  Function to return a list of servers of passed type                    
//                                                                         
//  Parameters:                                                            
//                                                                         
//    lpServerList - Pointer to an array of structures of wMaxReturn size  
//    wStartNum - Found server number to start returning                   
//    wStartNum - Maximum number of servers to return                      
//                                                                         
//  Returns:                                                               
//       SCP_SUCCESS - List is valid                                       
//       SCP_FAILURE - Could not access the network                        
//                                                                         
// 

WORD __export	FAR PASCAL SCP_GetServerList(WORD wDLL_ID, LPSCP_SERVER lpServerList, WORD wStartNum, LPWORD lpwMaxReturn)
{
	WORD  			wRetCode = SCP_SUCCESS;
	WORD				wCount=0;
	NWOBJ_ID			dwObjectID = (NWOBJ_ID) -1;
	NWOBJ_ID			dwAuditObjectID = (NWOBJ_ID) -1;
	BYTE				szServerName[50];
	NWFLAGS			byPropertiesFlag, byObjectFlag, byObjectSecurity;
	NWOBJ_TYPE		wSearchObjectType=OT_FILE_SERVER;
	NWOBJ_TYPE		wFoundServerType;
	NWCONN_HANDLE	nwConnectionHandle;

	if (NWGetDefaultConnectionID(&nwConnectionHandle) != SUCCESSFUL)
		return(wCount);

	wSearchObjectType=DLL_Clients[wDLL_ID].wSCP_Server_OT;

	while(NWScanObject(nwConnectionHandle,
				"*",
				wSearchObjectType,
				&dwObjectID,
				(LPSTR) szServerName, &wFoundServerType,
				&byPropertiesFlag, &byObjectFlag,
				&byObjectSecurity) == SUCCESSFUL && *lpwMaxReturn)
	{
		if (wStartNum == 0)
		{
			lstrcpy(lpServerList[wCount].szName, (LPSTR) szServerName);

			++wCount;
			--*lpwMaxReturn;
		}
		else
			--wStartNum;
	}

	*lpwMaxReturn = wCount;

	return(wRetCode);
}



WORD _QueryForSCPServerAddress(WORD wDLL_ID, LPSTR lpszServerName, LPBYTE lpServerNetwork, LPBYTE lpServerNode, LPWORD lpwServerSocket, LPWORD lpwErrorCode)
{
	*lpwErrorCode=NULL;	// No Error to start with

	// Get our Address
	{
		NWOBJ_ID			dwObjectID = (NWOBJ_ID) -1;
		BYTE				szServerName[50];
		NWFLAGS			byPropertiesFlag, byObjectFlag, byObjectSecurity;
		NWOBJ_TYPE		wSearchObjectType=OT_FILE_SERVER;
		NWOBJ_TYPE		wFoundServerType;
		NWCONN_HANDLE	nwConnectionHandle;
		NWCCODE			nwCCode;

		if (NWGetDefaultConnectionID(&nwConnectionHandle) == SUCCESSFUL)
		{
			wSearchObjectType=DLL_Clients[wDLL_ID].wSCP_Server_OT;

			if ((nwCCode=NWScanObject(nwConnectionHandle,
						(LPSTR) lpszServerName,
						wSearchObjectType,
						&dwObjectID,
						(LPSTR) szServerName, &wFoundServerType,
						&byPropertiesFlag, &byObjectFlag,
						&byObjectSecurity)) == SUCCESSFUL)
			{
				BYTE	yPropertyValue[128];
				BYTE	fMoreSegs, fFlags;

				_fmemset((LPSTR) yPropertyValue, 0x0, sizeof(yPropertyValue));

				if ((nwCCode = NWReadPropertyValue(nwConnectionHandle,
  									(LPSTR) szServerName,
									wFoundServerType,
									(LPSTR) "NET_ADDRESS",
									1,
									(LPBYTE) yPropertyValue,
									(LPBYTE) &fMoreSegs,
									(LPBYTE) &fFlags)) == SUCCESSFUL)
				{

					_fmemcpy(lpServerNetwork, (LPBYTE) &yPropertyValue[0], 4);
					_fmemcpy(lpServerNode, (LPBYTE) &yPropertyValue[4], 6);
					_fmemcpy(lpwServerSocket, (LPBYTE) &yPropertyValue[10], 2);

					return(SCP_SUCCESS);
				}
			}
		}
	}

	return(SCP_FAILURE);
}



// Ŀ
//                                                                         
//  SCP_SendPacket(WORD wDLL_ID, lpszServerName, lpwErrorCode)             
//                                                                         
//  Establish a logical connection with the specfied "SCP_SERVER"          
//                                                                         
//  Parameters:                                                            
//                                                                         
//    wDLL_ID        - Id that was returned from SCP_Register(...) call    
//    lpszSErverName - Name of server to establish a connection with.      
//    lpwErrorCode   - Pointer to return error code.                       
//                                                                         
//  Returns:                                                               
//       0..n        - Logical connection number                           
//       SCP_FAILURE - Could not establish a connection with specified     
//                     server, check lpwErrorCode for details.             
//                                                                         
// 

WORD __export	FAR PASCAL SCP_SendPacket(WORD wDLL_ID, LPSTR lpszServerName, LPBYTE lpDataPacket, WORD wPacketSize, LPWORD lpwErrorCode)
{
	int	ret, i;

	WORD	wServerSocket;			// Server socket established with OpenConnSocket(...)

	BYTE	ServerNetwork[4];		// Which network is the server located on
	BYTE	ServerNode[6];			// What node?
	WORD	wTempTransportTime;


	// Initiate the general SAP Query:
	if (_QueryForSCPServerAddress(wDLL_ID, (LPSTR) lpszServerName, (LPBYTE) &ServerNetwork[0], (LPBYTE) &ServerNode[0], (LPWORD) &wServerSocket, lpwErrorCode) != SCP_SUCCESS)
	{
		// Note: the lpwErrorCode field has already been set by
		//       _QueryForSCPServerAddress(..).  Most likely it
		//       was set to a timeout.
		//

		return((WORD) SCP_FAILURE);		// SCP Server NOT found!
	}

	// Send the SendPacket(...) command up to the server

	DLL_Clients[wDLL_ID].SendPacket.Cmd.wSCP = ACP_SIMPLE_CMD;

	// Initialize the IPX Packet
	DLL_Clients[wDLL_ID].SendPacket.Header.packetType=4;

	// Initialize the SCP ECB
	// Setup the Address to Send To
	DLL_Clients[wDLL_ID].SendPacket.theECB.ESRAddress = NULL;
	DLL_Clients[wDLL_ID].SendPacket.theECB.socketNumber = wServerSocket;

	DLL_Clients[wDLL_ID].SendPacket.theECB.fragmentCount=2;
	// IPX Header

	DLL_Clients[wDLL_ID].SendPacket.theECB.fragmentDescriptor[0].address=(void far *) &DLL_Clients[wDLL_ID].SendPacket.Header;
	DLL_Clients[wDLL_ID].SendPacket.theECB.fragmentDescriptor[0].size=sizeof(IPXHeader);

	// SCP Command
	DLL_Clients[wDLL_ID].SendPacket.theECB.fragmentDescriptor[1].address=(void far *) &DLL_Clients[wDLL_ID].SendPacket.Cmd;
	DLL_Clients[wDLL_ID].SendPacket.theECB.fragmentDescriptor[1].size=sizeof(SCP_COMMAND);

	// For a Direct SEND NOT a BROADCAST!
	_fmemcpy(&DLL_Clients[wDLL_ID].SendPacket.Header.destination.network[0], &ServerNetwork[0], sizeof(DLL_Clients[wDLL_ID].SendPacket.Header.destination.network));
	_fmemcpy(&DLL_Clients[wDLL_ID].SendPacket.Header.destination.node[0], &ServerNode[0], sizeof(DLL_Clients[wDLL_ID].SendPacket.Header.destination.node));
	_fmemcpy(&DLL_Clients[wDLL_ID].SendPacket.Header.destination.socket[0], &wServerSocket, sizeof(DLL_Clients[wDLL_ID].SendPacket.Header.destination.socket));

	IPXGetLocalTarget(IPXTaskID,
		(LPBYTE) &DLL_Clients[wDLL_ID].SendPacket.Header.destination,
		(LPBYTE) &DLL_Clients[wDLL_ID].SendPacket.theECB.immediateAddress[0],
		&wTempTransportTime);

	if (lpDataPacket)
	{
		++DLL_Clients[wDLL_ID].SendPacket.theECB.fragmentCount;
		DLL_Clients[wDLL_ID].SendPacket.theECB.fragmentDescriptor[2].address=(void far *) lpDataPacket;
		DLL_Clients[wDLL_ID].SendPacket.theECB.fragmentDescriptor[2].size=wPacketSize;
	}

	// Do the send out the of SCP packet
	IPXSendPacket(IPXTaskID, (ECB FAR *) &DLL_Clients[wDLL_ID].SendPacket.theECB);

	// This MUST be done otherwise our sends don't work.
	IPXRelinquishControl();

	// Verify we have sent the packet...
	{
		DWORD	dwStartTimeOut=NULL;

		// Get Start Time
		dwStartTimeOut=GetCurrentTime();

		while(((GetCurrentTime() - dwStartTimeOut) < ((DWORD) 2*1000L)) && DLL_Clients[wDLL_ID].SendPacket.theECB.inUseFlag != NULL)
		{
			IPXRelinquishControl();
		}
	}

	if (DLL_Clients[wDLL_ID].SendPacket.theECB.inUseFlag == NULL)
		return(SCP_SUCCESS);
	else
		return(SCP_FAILURE);
}


/***********************************************/ 
/* AlertTrack - (SCP) Simple Core Protocol API */ 
/***********************************************/ 

WORD __export	FAR PASCAL AlertTrack_SendAlert(WORD wDLL_ID, LPSTR lpszServerName, LPSTR lpszRecipient, LPSTR lpszFromAppName, LPSTR szMessage, BYTE yPriority)
{
	ALERT_DATA_PACKET	AlertTrackPacket;
	WORD					wErrorCode;

	_fmemset((LPBYTE) &AlertTrackPacket, 0x0, sizeof(ALERT_DATA_PACKET));

	AlertTrackPacket.yPacketType = PACKET_TYPE_RECIPIENT;

	_fstrcpy((LPSTR) &AlertTrackPacket.szRecipientName, lpszRecipient);
	_fstrcpy((LPSTR) &AlertTrackPacket.szFromAppName, lpszFromAppName);
	_fstrcpy((LPSTR) &AlertTrackPacket.szMessage, szMessage);

	AlertTrackPacket.yPriority = yPriority;

	return(SCP_SendPacket(wDLL_ID, lpszServerName, (LPBYTE) &AlertTrackPacket, sizeof(ALERT_DATA_PACKET), (LPWORD) &wErrorCode));
}


WORD	__export	FAR PASCAL AlertTrack_Register()
{
	return(SCP_Register(OT_ALERTTRACK_SERVER));
}


WORD __export	FAR PASCAL AlertTrack_DeRegister(WORD wDLL_ID)
{
	return(SCP_DeRegister(wDLL_ID));
}

WORD __export	FAR PASCAL AlertTrack_GetServerCount(WORD wDLL_ID)
{
	return(SCP_GetServerCount(wDLL_ID));
}

WORD __export	FAR PASCAL AlertTrack_GetServerList(WORD wDLL_ID, LPSCP_SERVER lpServerList, WORD wStartNum, LPWORD lpwMaxReturn)
{
	return(SCP_GetServerList(wDLL_ID, lpServerList, wStartNum, lpwMaxReturn));
}



