/**************************************************************************/
/*    ALERTCOM.H - Function prototypes and defines for ALERTCOM.DLL       */
/*                                                                        */
/*    Copyright (c) e. g. Software Inc, 1993.  All Rights Reserved.       */
/*                                                                        */
/*                e.g. Software Inc.                                      */
/*                319 Sw Washington                                       */
/*                Suite 706                                               */
/*                Portland OR, 97201                                      */
/*                (503) 294-7025                                          */
/*                (503) 294-7130 FAX                                      */
/**************************************************************************/

/******************/
/*  STRUCTURES    */
/******************/
typedef	struct
{
	BYTE	szName[48];
}	SCP_SERVER, far * LPSCP_SERVER, * NPSCP_SERVER;

/******************/
/*  DEFINES       */
/******************/

#define	SCP_SUCCESS	(0)
#define	SCP_FAILURE	(-1)
#define	SCP_TIMEOUT	(-2)


/*********************/
/* GLOBAL PROTOTYPES */
/*********************/

/***********************************************/
/* Generic - (SCP) Simple Core Protocol API    */
/***********************************************/
WORD __export	FAR PASCAL SCP_Register(WORD wSCPServerOT);
WORD __export	FAR PASCAL SCP_DeRegister(WORD wID);
WORD __export	FAR PASCAL SCP_GetServerCount(WORD wDLL_ID);
WORD __export	FAR PASCAL SCP_GetServerList(WORD wDLL_ID, LPSCP_SERVER lpServerList, WORD wStartNum, LPWORD lpwMaxReturn);
WORD __export	FAR PASCAL SCP_SendPacket(WORD wDLL_ID, LPSTR lpszServerName, LPBYTE lpDataPacket, WORD wPacketSize, LPWORD lpwErrorCode);

/***********************************************/

/***********************************************/
/* AlertTrack - (SCP) Simple Core Protocol API */
/***********************************************/

/****************************************************************/
/* You must call the register function at the start of your app */
/*                                                              */
/* returns: WORD wDLL_Id                                        */
/****************************************************************/
WORD __export	FAR PASCAL AlertTrack_Register();

/****************************************************************/
/* You must call the unregister function at the end of your app */
/*                                                              */
/* Var: the handle returned by AlertTrack_Register              */
/****************************************************************/
WORD __export	FAR PASCAL AlertTrack_DeRegister(WORD wDLL_Id);

/****************************************************************/
/* Returns the number of AlertTrack servers found               */
/*                                                              */
/* Var: the handle returned by AlertTrack_Register              */
/****************************************************************/
WORD __export	FAR PASCAL AlertTrack_GetServerCount(WORD wDLL_ID);

/****************************************************************************/
/* Returns a list of AlertTrack servers                                     */
/* You are responsible to allocate the buffer for the list -                */
/* Numberofservers * 48                                                     */
/*                                                                          */
/* Var: WORD wDLL_ID the handle returned by AlertTrack_Register             */
/*      LPSCP_SERVER lpServerList - pointer to the list buffer              */                                                  
/*      WORD wStartNum Index to AlertTrack server (0 - for first one        */
/*      LPWORD lpwMaxReturn Max number of servers you want                  */                
/*                                                                          */
/* returns LPWORD lpwMaxReturn number of servers found                      */
/*                                                                          */
/*                                                                          */
/****************************************************************************/
WORD __export	FAR PASCAL AlertTrack_GetServerList(WORD wDLL_ID, LPSCP_SERVER lpServerList, WORD wStartNum, LPWORD lpwMaxReturn);


/****************************************************************************/
/* Send a message to an AlertTrack server                                   */
/*                                                                          */
/* The alert is addressed to a recipient in the system which should         */
/* be configured to receive the alert through the different devices.        */
/*                                                                          */
/* Var: WORD wDLL_ID the handle returned by AlertTrack_Register             */
/*      LPSTR lpszServerName - AlertTrack server name, you may              */
/*                             specify "*" for the first AlertTrack         */
/*                             server to be found                           */
/*      LPSTR lpszRecipient -  Recipient name, you may specify "*"          */
/*                             for any recipient                            */
/*      LPSTR lpszFromAppName- You application name                         */
/*      BYTE  yPriority      - Severity/Priority (0 highest, 5 lowest       */
/*                                                                          */
/****************************************************************************/
WORD __export	FAR PASCAL AlertTrack_SendAlert(WORD wDLL_ID, LPSTR lpszServerName, LPSTR lpszRecipient, LPSTR lpszFromAppName, LPSTR szMessage, BYTE yPriority);



